var Mesh = {
    create: function (bridge, name) {
        var self = {
            id: bridge.LoadMesh(),
            name: name,
            isReleased: false,
        };

        self.release = function () {
            bridge.ReleaseMesh(self);
            self.isReleased = true;
        };

        var streams = {
            Positions: 0,
            Normals: 1,
            TexCoords: 2,
            Tangents: 3,
            Colors: 4,
        };

        Object.defineProperty(self, 'positions', {
            enumerable: true,
            configurable: false,
            get: function () { return self._positions; },
            set: function (values) {
                self._positions = values;
                bridge.SetMeshData(self, streams.Positions, values, values.length / 3);
            }
        });

        Object.defineProperty(self, 'normals', {
            enumerable: true,
            configurable: false,
            get: function () { return self._normals; },
            set: function (values) {
                self._normals = values;
                bridge.SetMeshData(self, streams.Normals, values, values.length / 3);
            }
        });

        Object.defineProperty(self, 'texCoords', {
            enumerable: true,
            configurable: false,
            get: function () { return self._texCoords; },
            set: function (values) {
                self._texCoords = values;
                bridge.SetMeshData(self, streams.TexCoords, values, values.length / 2);
            }
        });

        Object.defineProperty(self, 'colors', {
            enumerable: true,
            configurable: false,
            get: function () { return self._colors; },
            set: function (values) {
                self._colors = values;
                bridge.SetMeshData(self, streams.Colors, values, values.length / 4);
            }
        });

        Object.defineProperty(self, 'primitiveType', {
            enumerable: true,
            configurable: false,
            get: function () { return self._primitiveType; },
            set: function (value) {
                self._primitiveType = value;
                bridge.SetMeshPrimitiveType(self, value);
            }
        });

        Object.defineProperty(self, 'boundingBox', {
            enumerable: true,
            configurable: false,
            set: function (value) {
                bridge.SetMeshBoundingBox(self, value);
            }
        });

        return self;
    },
}
