Resources = {}
Resources.__index = Resources

Mesh = Object.newClass()
function Mesh.create()
	local mesh = Mesh.new()
	
	Object.defineProperty(mesh, "id", {
		value = bridge.loadMesh(bridge.context)
	})

	Object.defineProperty(mesh, "positions", {
		set = function(positions)
			bridge.setMeshData(bridge.context, mesh.id, 0, positions, 3)
		end
	})

	Object.defineProperty(mesh, "normals", {
		set = function(normals)
			bridge.setMeshData(bridge.context, mesh.id, 1, normals, 3)
		end
	})

	return mesh
end

Material = {}
function Material.create(name)
	local material = {
		id = bridge.loadMaterial(bridge.context, name)
	}

	return material
end

MaterialInstance = {}
function MaterialInstance.create(material)
	if material == nil then
		console.error("Could not create material instance with empty material.")
		return nil
	end

	local m = {
		id = bridge.loadMaterialInstance(bridge.context, material.id)
	}

	function m.setProperty(name, value)
		bridge.setMaterialInstanceProperty(bridge.context, m.id, name, value)
	end

	return m
end

Model = {}
function Model.create()
	local model = {
		
	}

	return model
end

function Resources.new(runtime)
	local resources = {
		runtime = runtime,
	}

	setmetatable(resources, Resources)

	return resources
end

function Resources:loadModel(path)
	local model = Model.create()

	model.id = bridge.loadModel(bridge.context, path, -1, 0)

	return model
end


function Resources:createMesh()
	return Mesh.create()
end

function Resources:loadMaterial(name)
	return Material.create(name)
end

function Resources:loadMaterialInstance(material)
	return MaterialInstance.create(material)
end
