SurfaceOut surfaceFunction(VertexIn In)
{
  SurfaceOut Out = createSurfaceOut();

#ifdef COGS_BASIC_SKY_LOD
  const float lod = float(COGS_BASIC_SKY_LOD);
#else
  const float lod = 0.0;
#endif

#if defined(COGS_BASIC_SKY_SOURCE_DIFFUSE)
  vec4 textureColor = texture2DLodEXT(diffuseMap, In.TexCoord, lod);
#elif defined(COGS_BASIC_SKY_SOURCE_CUBE)
  vec4 textureColor = textureCubeLodEXT(cubeMap, In.Direction.xzy, lod);
#elif defined(COGS_BASIC_SKY_SOURCE_ENV_SKY)
  vec4 textureColor = textureCubeLodEXT(environmentSky, In.Direction.xzy, lod);
  textureColor.rgb *= environmentBrightness();
#elif defined(COGS_BASIC_SKY_SOURCE_ENV_RADIANCE)
  vec4 textureColor = textureCubeLodEXT(environmentRadiance, In.Direction.xzy, lod);
  textureColor.rgb *= environmentBrightness();
#elif defined(COGS_BASIC_SKY_SOURCE_ENV_IRRADIANCE)
  vec4 textureColor = textureCubeLodEXT(environmentIrradiance, In.Direction.xzy, lod);
  textureColor.rgb *= environmentBrightness();
#else
  vec4 textureColor = vec4(1, 1, 1, 1);
#endif

  vec3 color = mix(diffuseColor().rgb, textureColor.rgb * diffuseColor().rgb, textureColor.a) * brightness();

  Out.Color = vec4(color, diffuseColor().a * textureColor.a);
  Out.Normal = vec3(1, 1, 1);

  return Out;
}
