#ifndef COGS_CORE_BLUE_NOISE_HLSL
#define COGS_CORE_BLUE_NOISE_HLSL

#include "Engine/Common.hlsl"

/* Texture2D blueNoise_HDR_R; */
/* Texture2D blueNoise_HDR_RG; */
/* Texture2D blueNoise_HDR_RGB; */
/* Texture2D blueNoise_HDR_RGBA; */
/* Texture2D blueNoise_LDR_R; */
/* Texture2D blueNoise_LDR_RG; */
/* Texture2D blueNoise_LDR_RGB; */
Texture2D blueNoise_LDR_RGBA;
Texture2D blueNoiseStable_LDR_RGBA;
//SamplerState blueNoiseSampler;

float blueNoise(int2 tex)
{
  tex += blueNoiseOffset.xy;
  return blueNoise_LDR_RGBA.Load(int3(tex&0x3F, 0)).r;
}
float3 blueNoise3(int2 tex)
{
  tex += blueNoiseOffset.xy;
  return blueNoise_LDR_RGBA.Load(int3(tex&0x3F, 0)).rgb;
}
float4 blueNoise4(int2 tex)
{
  tex += blueNoiseOffset.xy;
  return blueNoise_LDR_RGBA.Load(int3(tex&0x3F, 0));
}

float blueNoiseStable(int2 tex)
{
  tex += blueNoiseOffset.zw;
  return blueNoiseStable_LDR_RGBA.Load(int3(tex&0x3F, 0)).r;
}
float3 blueNoise3Stable(int2 tex)
{
  tex += blueNoiseOffset.zw;
  return blueNoiseStable_LDR_RGBA.Load(int3(tex&0x3F, 0)).rgb;
}
float4 blueNoise4Stable(int2 tex)
{
  tex += blueNoiseOffset.zw;
  return blueNoiseStable_LDR_RGBA.Load(int3(tex&0x3F, 0));
}

#endif
