void geometryFunction(point VertexIn In[1], inout TriangleStream<VertexOut> OutputStream)
{
  float3 p = In[0].Position.xyz / In[0].Position.w;

  float2 viewportScale = 1.0 / (0.5 * viewportSize);

  float2 center = viewportSize * (0.5 + 0.5 * p.xy);

  float2 ll = floor(center + float2(-0.5, -0.5) * pointSize);

#ifdef COGS_POINT_MATERIAL_DEPTH_BIAS24
  // Pushes z depthBias number of ULP's towards camera.
  p.z = 1.0 / ((1.0 / p.z) + depthBias / (1 << 23));
#endif

  VertexOut vertex = (VertexOut)0;
  float2 v0 = ll * viewportScale - float2(1, 1);
  vertex.Position = float4(v0, p.z, 1.0);
  vertex.Weights = float4(0, 0, 0, 0);
  transferAttributes(In[0], vertex);
  OutputStream.Append(vertex);

  float2 v1 = (ll + float2(1, 0) * pointSize) * viewportScale - float2(1, 1);
  vertex.Position = float4(v1, p.z, 1.0);
  vertex.Weights = float4(1, 0, 0, 0);
  transferAttributes(In[0], vertex);
  OutputStream.Append(vertex);

  float2 v2 = (ll + float2(0, 1) * pointSize) * viewportScale - float2(1, 1);
  vertex.Position = float4(v2, p.z, 1.0);
  vertex.Weights = float4(0, 1, 0, 0);
  transferAttributes(In[0], vertex);
  OutputStream.Append(vertex);

  float2 v3 = (ll + float2(1, 1) * pointSize) * viewportScale - float2(1, 1);
  vertex.Position = float4(v3, p.z, 1.0);
  vertex.Weights = float4(1, 1, 0, 0);
  transferAttributes(In[0], vertex);
  OutputStream.Append(vertex);
}
