#ifndef COGS_COMMON_GLSL
#define COGS_COMMON_GLSL

struct SurfaceOut
{
  vec4 Color;
  vec3 Specular;
  float SpecularPower;
  vec3 Emissive;
  vec3 Normal;

#ifdef COGS_USE_OBJECTID
  int objectId;
#endif

#ifdef COGS_CUSTOM_DEPTH_WRITE
  float Depth;
#endif
};

SurfaceOut createSurfaceOut()
{
  SurfaceOut t;
  t.Color = vec4(0, 0, 0, 1);
  t.Specular = vec3(0);
  t.SpecularPower = 0.0;
  t.Emissive = vec3(0);
  t.Normal = vec3(0);
#ifdef COGS_USE_OBJECTID
  t.objectId = int(objectId());
#endif

#ifdef COGS_CUSTOM_DEPTH_WRITE
  t.Depth = 0;
#endif
  return t;
}

#ifndef VERTEX_FUNCTION
#define VERTEX_FUNCTION vertexFunction
#endif

#ifndef SURFACE_FUNCTION
#define SURFACE_FUNCTION surfaceFunction
#endif

//#define COGS_LIGHT_MASK_PHONG 1
//#define COGS_LIGHT_MASK_INDIRECT 64

int GetMaterialId()
{
  int materialId = 0;

//#if defined(COGS_LIGHT_MODEL_PHONG)
//  materialId += COGS_LIGHT_MASK_PHONG;
//#elif defined(COGS_LIGHT_MODEL_STANDARD)
//  materialId += 4;
//#endif

#ifdef COGS_SURFACE_CLOSED
  materialId += 16;
#endif

//#ifdef COGS_INDIRECT_LIGHTING_FULL
//  materialId += COGS_LIGHT_MASK_INDIRECT;
//#endif

  return materialId;
}

#endif // COGS_COMMON_GLSL
