#version 300 es
precision highp float;
precision highp int;
precision mediump sampler2DArray;

uniform ImguiBuffer
{
  mat4 ProjectionMatrix;
  int ShowAlpha;
  int TexMode;
  int Offset;
};

uniform sampler2D texture0;
uniform sampler2DArray texarray;
uniform samplerCube texcube;

in vec4 col;
in vec2 uv;

out vec4 fragColor;

void main()
{

  vec4 texColor;
  if (TexMode == 0) {
    texColor = texture(texture0, uv);
  }
  else if (TexMode == 1) {
    texColor = texture(texarray, vec3(uv, Offset));
  }
  else if (TexMode == 2) {
    // Should this be cube sampling?
    texColor = vec4(0, 1, 0, 1);
  }

  if (ShowAlpha == 1)
  {
    texColor = vec4(texColor.aaa, 1);
  }
  else if (ShowAlpha == 2) {
    texColor = vec4(texColor.rrr, 1);
  }
  vec4 color = col * texColor;

  if(col.a == -1.0) {
    color = vec4(col.aaa, 1);
  }

  fragColor = color;
}

