#include "Engine/Common.hlsl"
#include "Engine/PhongLighting.hlsl"

Texture2D normalTexture;
texture2D indirectLightTexture;

struct VertexIn
{
  float4 Position : SV_Position;
  float4 ScreenPosition : TEXCOORD0;
  float2 TexCoords : TEXCOORD1;
};

struct PixelOut
{
  float4 Color : SV_Target;
  float Depth : SV_Depth;
};

float4 main(VertexIn In, float4 ScreenPos : SV_Position) : SV_Target
{
  int3 p = int3(ScreenPos.xy, 0);
  const float3 N = normalTexture.Load(p).xyz;

  float W = 1;
  float4 V = indirectLightTexture.Load(p);
  for (int j = -2; j <= 2; j++) {
    for (int i = -2; i <= 2; i++) {
      if ((i == 0) && (j == 0)) continue;

      int3 t = p + int3(i, j, 0);

      float w = 100.0*max(0.0, dot(N, normalTexture.Load(t).xyz) - 0.99);
      if (0 < w) {
        W += w;
        V += w*indirectLightTexture.Load(t);
      }
    }
  }

  return (1.0 / W)*V;
}
