
#include "SpriteCommon.hlsl"

VertexOut vertexFunction(VertexIn In)
{
  VertexOut Out = (VertexOut)0;

  float4 VsPosition;

#if defined (COGS_SPRITES_VIEWTRANSFORM)
  Out.WorldPosition = mul(float4(In.Position.xyz,1), worldMatrix);
  VsPosition = mul(Out.WorldPosition, worldToClipMatrix);
#elif defined (COGS_SPRITES_PIXELTRANSFORM)
  float2 viewportScale = 1.0 / viewportSize;
  float2 scaled = In.Position.xy * viewportScale;
  float2 ndc = float2(scaled.x, scaled.y) * 2.0f - float2(1, 1);
#ifdef COGS_REVERSE_DEPTH
  In.Position.z = -In.Position.z;
#endif
  VsPosition = float4(ndc, In.Position.z*0.5+0.5, 1);
#else
#ifdef COGS_REVERSE_DEPTH
  In.Position.z = -In.Position.z;
#endif
  VsPosition = mul(float4(In.Position.xy, In.Position.z*0.5+0.5, 1), worldMatrix);
#endif

  float4 VsTexCoord;
  VsTexCoord.xz = imageFlip.x * (1 - In.TexCoord.xz) + (1 - imageFlip.x) * In.TexCoord.xz;
  VsTexCoord.yw = imageFlip.y * (1 - In.TexCoord.yw) + (1 - imageFlip.y) * In.TexCoord.yw;

  float index = In.Position.w;
  if (VsPosition.z < -VsPosition.w) index = 0.0;

  Out.TexCoord.zw = (float2)0;
  quadExpand(Out.Position,
             Out.Weights,
             Out.TexCoord.xy,
             VsPosition,
             In.Normal,
             VsTexCoord,
             index);

  return Out;
}
