SurfaceOut surfaceFunction(VertexIn In)
{
  SurfaceOut Out = (SurfaceOut)0;

  float4 sprite = spriteTexture.Sample(spriteTextureSampler, In.TexCoord.xy);

#ifdef COGS_TEXT_SDF
  float glyphAlpha = smoothstep(0.45, 0.55, sprite.a);

  float alpha = glyphAlpha * spriteColor.a;

  if (alpha < 0.01) discard;

  Out.Color = float4(spriteColor.rgb * sprite.rgb * alpha, alpha);
#else
  float alpha = sprite.a * spriteColor.a;

  if (alpha < 0.01) discard;

  Out.Color = float4(spriteColor.rgb * sprite.rgb * alpha, alpha);
#endif

  return Out;
}
